﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;

namespace Sobel
{
    public partial class Form1 : Form
    {
            static string curpic = "chick.bmp";
            static Bitmap img = new Bitmap(Environment.CurrentDirectory + "\\" + curpic);   //img is shared globally
            int sliderval = 190;    //default sensitivity set here
            static int picWIDTH = img.Width; //TO BE SET
	        static int picHEIGHT = img.Height;//TO BE SET
            int[,] BWArray = new int[picWIDTH, picHEIGHT];  //array that contains grayscale pixels
            int[,] SobelData = new int[picWIDTH, picHEIGHT];    //array that contains outlined photo
	        int[,] xmask = new int[3,3]; //horizontal sobel mask
            int[,] ymask = new int[3,3]; //vertical sobel mask
        public Form1()
        {
            
            InitializeComponent();
            img = MedianFilter(img, 7);
            trackbar.Maximum = 255;
            trackbar.Minimum = 0;
            trackbar.Value = sliderval;
            initmask(); //init mask arrays         
            Bitmap orig = ToGrayscale();
            InitializeSolidBW(BWArray, orig);   //store grayscale image into BWArray
            sobel(SobelData, BWArray);
            Draw_ImageBW(SobelData);
            solid[,] Orig1;
            Orig1 = new solid[picWIDTH, picHEIGHT];
            Orig1 = LineLayer(SobelData);
            tb.Text += "width: " + picWIDTH + ", height: " + picHEIGHT + Environment.NewLine;
            for (int i = 0; i < 100; i++)
                for (int j = 0; j < 100; j++)
                    tb.Text += SobelData[i, j] + Environment.NewLine;

        }
        /********************************************************************/
        /*  will be superfluous once concatenated with code_drawup (4/8/13) */
        /********************************************************************/
        public struct solid
        {
            public bool visited;
            public bool IsLine;
            public int group, rgb_sum, r, g, b;
        }

        /// <summary>
        /// simple struct to hold together rgb values for "ColourDistance" function
        /// NOTE: may turn out to be obsolete by just calling c1 and c2 versus e1 and e2
        /// </summary>
        /// <param name="r, g, b">ints representing RGB values</param>
        public struct RGB
        {
            public int r, g, b;
            public bool READY;
        }

        public static Bitmap MedianFilter(Bitmap sourceBitmap, int matrixSize, int bias = 0, bool grayscale = false)
        {
            BitmapData sourceData =
                       sourceBitmap.LockBits(new Rectangle(0, 0,
                       sourceBitmap.Width, sourceBitmap.Height),
                       ImageLockMode.ReadOnly,
                       PixelFormat.Format32bppArgb);


            byte[] pixelBuffer = new byte[sourceData.Stride *
                                          sourceData.Height];


            byte[] resultBuffer = new byte[sourceData.Stride *
                                           sourceData.Height];


            Marshal.Copy(sourceData.Scan0, pixelBuffer, 0,
                                       pixelBuffer.Length);


            sourceBitmap.UnlockBits(sourceData);


            if (grayscale == true)
            {
                float rgb = 0;


                for (int k = 0; k < pixelBuffer.Length; k += 4)
                {
                    rgb = pixelBuffer[k] * 0.11f;
                    rgb += pixelBuffer[k + 1] * 0.59f;
                    rgb += pixelBuffer[k + 2] * 0.3f;


                    pixelBuffer[k] = (byte)rgb;
                    pixelBuffer[k + 1] = pixelBuffer[k];
                    pixelBuffer[k + 2] = pixelBuffer[k];
                    pixelBuffer[k + 3] = 255;
                }
            }


            int filterOffset = (matrixSize - 1) / 2;
            int calcOffset = 0;


            int byteOffset = 0;

            List<int> neighbourPixels = new List<int>();
            byte[] middlePixel;


            for (int offsetY = filterOffset; offsetY <
                sourceBitmap.Height - filterOffset; offsetY++)
            {
                for (int offsetX = filterOffset; offsetX <
                    sourceBitmap.Width - filterOffset; offsetX++)
                {
                    byteOffset = offsetY *
                                 sourceData.Stride +
                                 offsetX * 4;


                    neighbourPixels.Clear();


                    for (int filterY = -filterOffset;
                        filterY <= filterOffset; filterY++)
                    {
                        for (int filterX = -filterOffset;
                            filterX <= filterOffset; filterX++)
                        {


                            calcOffset = byteOffset +
                                         (filterX * 4) +
                                (filterY * sourceData.Stride);


                            neighbourPixels.Add(BitConverter.ToInt32(
                                             pixelBuffer, calcOffset));
                        }
                    }


                    neighbourPixels.Sort();

                    middlePixel = BitConverter.GetBytes(
                                       neighbourPixels[filterOffset]);


                    resultBuffer[byteOffset] = middlePixel[0];
                    resultBuffer[byteOffset + 1] = middlePixel[1];
                    resultBuffer[byteOffset + 2] = middlePixel[2];
                    resultBuffer[byteOffset + 3] = middlePixel[3];
                }
            }


            Bitmap resultBitmap = new Bitmap(sourceBitmap.Width,
                                             sourceBitmap.Height);


            BitmapData resultData =
                       resultBitmap.LockBits(new Rectangle(0, 0,
                       resultBitmap.Width, resultBitmap.Height),
                       ImageLockMode.WriteOnly,
                       PixelFormat.Format32bppArgb);


            Marshal.Copy(resultBuffer, 0, resultData.Scan0,
                                       resultBuffer.Length);


            resultBitmap.UnlockBits(resultData);


            return resultBitmap;
        }

        /***********************************************************/
        /***********************************************************/
        //USED ONLY TO TEST IF BW IMAGE STORED SUCCESSFULLY INTO ARRAY
        /***********************************************************/
        /***********************************************************/
        public void Draw_ImageBW(int[,] pixel_array)
        {
            Bitmap New_Image = new Bitmap(picWIDTH, picHEIGHT);
            for (int i = 0; i < picWIDTH; i++)
            {
                for (int j = 0; j < picHEIGHT; j++)
                {
                    int val = pixel_array[i, j];
                    if (val < 0)
                        val = 0;
                    New_Image.SetPixel(i, j, Color.FromArgb(val, val, val));
                }
            }

            pb.Image = New_Image;


        }
        /* RETURNS ARRAY OF TYPE SOLID WITH LINE LOCATIONS AND WEIGHTS
         * ONLY CONCERNED WITH STORING LINES; LATER INIT FUNCTION 
         "InitializeSolid" WILL FILL IN OTHER PIXELS*/
        public solid[,] LineLayer(int[,] pixel_array)
        {
            solid[,] linelayer; //create no solid array
            linelayer = new solid[picWIDTH, picHEIGHT];
            for (int i = 0; i < picWIDTH; i++)
            {
                for (int j = 0; j < picHEIGHT; j++)
                {

                    int val = pixel_array[i, j];
                    if (val < 0)    //don't allow negative values
                        val = 0;
                    if (val != 255) //if line, set line values. will be skipped over
                                    //by InitializeSolid function
                    {
                        linelayer[i,j].r = linelayer[i,j].g = linelayer[i,j].b = val;
                        linelayer[i,j].IsLine = true;
                        linelayer[i, j].visited = true;
                    }
                    else
                        linelayer[i, j].IsLine = false;
                }
            }

            return linelayer;
        }

        public Bitmap ToBitmap(int[,] pixel_array)
        {
            Bitmap New_Image = new Bitmap(picWIDTH, picHEIGHT);
            for (int i = 0; i < picWIDTH; i++)
            {
                for (int j = 0; j < picHEIGHT; j++)
                {

                    int val = pixel_array[i, j];
                    if (val < 0)
                        val = 0;
                    New_Image.SetPixel(i, j, Color.FromArgb(val, val, val));
                }
            }

            return New_Image;
        }
        /***********************************************************/
        //GETS BW IMAGE AND STORES IT INTO BWArray******************/
        public void InitializeSolidBW(int[,] pixel_array, Bitmap orig)  //MODIFIED InitializeSolidBW for IDENTICAL RGB values
        {
            int R;
            for (int i = 0; i < picWIDTH; i++)
            {
                for (int j = 0; j < picHEIGHT; j++)
                {
                    Color c1 = orig.GetPixel(i, j);
                    R = c1.R;
                    pixel_array[i,j] = R;
                }
            }
        }

        public static Color ToGrayscaleColor(Color color)
        {
            var level = (byte)((color.R + color.G + color.B) / 3);
            var result = Color.FromArgb(level, level, level);
            return result;
        }
        public Bitmap ToGrayscale() //gets image, converts to grayscale, and returns new bitmap
        {
            Bitmap bitmap = new Bitmap(Environment.CurrentDirectory + "\\" + curpic);
            Bitmap result = new Bitmap(bitmap.Width, bitmap.Height);
            for (int x = 0; x < bitmap.Width; x++)
            {
                for (int y = 0; y < bitmap.Height; y++)
                {
                    var grayColor = ToGrayscaleColor(bitmap.GetPixel(x, y));
                    result.SetPixel(x, y, grayColor);
                }
            }
            return result;
        }

        //*************************sobel() subroutine*************************
//
//  purpose: take an image and weigh the pixels to find the differences
//           and then save the differences (edges) only
//
//   input: black and white video data in the BWArray array
//          xmask and ymask arrays holding the weights to be given to adjacent pixels
//
//   output: sobel data that is stored in the SobelData array  which is
//           then used in the translate subroutine
//
//********************************************************************

public void sobel(int[,] SobelData, int[,] BWArray)
{    
    int sumx, sumy, sum; //sum based on xmask weights
                            //sum based on ymask weights
                             //overall absolute value of combined weights-->is the final sobel data
    for ( int x1 = 0; x1 < picHEIGHT; x1++) //fill in rows 120 to 1 COULD BE < (ml)
	{
		for ( int y1 = 0; y1 < picWIDTH; y1++) //fill in columns 120 to 1	COULD BE < (ml)
		{
             sumx = 0; //reinitialize these to zero every time through the loop
             sumy = 0;
             SobelData[y1,x1] = 255; //initialize each element of the array (avoids separate initializing loop)
             
             //if not on the border of the image, step into the if statement
			 if ( y1 != 0 && y1 != (picWIDTH - 1) && x1 != 0 && x1 != picHEIGHT - 1)
             {
                 for (int i = -1; i <= 1; i++)    //work through the masks (MILES NOTE: MAYBE <1 (?) )
				 {
                     for (int j = -1; j <= 1; j++)  //move across columns first, then go to next row
					 {
                         //pic is stored (col, row) while the mask is (row,col)
                         //x and i refer to rows, y and j refer to columns
                         sumx += ( BWArray[(y1 + j),(x1 + i)] * xmask[(i + 1),(j + 1)] ); //switching to "i+1" because xmask/ymask arrays changed (ml)
                         sumy += ( BWArray[(y1 + j),(x1 + i)] * ymask[(i + 1),(j + 1)] );
                     }
                 }
                 
                 sum = Math.Abs(sumx) + Math.Abs(sumy); //the larger the overall absolute value, the greater the difference
                                             //between the adjacent pixels
                     
                 //adjust the meaning of "black" and "white" via the slider control on the form
                 if (sum >= (255 - sliderval))
                     sum = 255;
                 else
                     if (sum <= sliderval)
                         sum = 0;
                     else
                         sum = 0;
        
                 SobelData[y1,x1] = 255 - sum; //subtract so edges are outlined in black, everything else is white
             }
        }
    }
}

/**********************initmask() subroutine*************************
'
'   purpose: initialize the masks used by sobel() giving adjacent
'            pixels the appropriate "weight"
'
'   input: none
'
'   output: two matrices defining the weights to be used on adjacent
'           pixels when finding the sobel data
'
'   note: increasing the values in the masks will increase the
'           sensitivity of sobel...however, for the most part this
'           simply means more "noise" rather than better defined edges
'   also: the numbers have to stay relatively small because of the
'           sobel computations-->the bigger the multiplier in the matrix
'           the higher the results are on average, meaning more pixels
'           are black more often (hence the noise issue)
'
'********************************************************************/
public void initmask()
{
    //   -1  0   1
    //   -2  0   2
    //   -1  0   1
    xmask[0, 0] = -1;       //********ALL VALUES WERE +1 (i.e. [0,0] was [1,1]); OTHER PARTS OF CODE USING XMASK AND YMASK MIGHT NOW BE FUCKED/NEED TO BE CHANGED (ml)
    xmask[0, 1] = 0;
    xmask[0, 2] = 1;
    xmask[1, 0] = -2;
    xmask[1, 1] = 0;
    xmask[1, 2] = 2;
    xmask[2, 0] = -1;
    xmask[2, 1] = 0;
    xmask[2, 2] = 1;

    //    1   2   1
    //    0   0   0
    //   -1  -2  -1
    ymask[0, 0] = 1;
    ymask[0, 1] = 2;
    ymask[0, 2] = 1;
    ymask[1, 0] = 0;
    ymask[1, 1] = 0;
    ymask[1, 2] = 0;
    ymask[2, 0] = -1;
    ymask[2, 1] = -2;
    ymask[2, 2] = -1;
}

private void trackbar_Scroll(object sender, EventArgs e)    //draw image and save to "img" when trackbar is changed
{
    sliderval = trackbar.Value;
    sobel(SobelData, BWArray);
    Draw_ImageBW(SobelData);
    img = ToBitmap(SobelData);
}

private void button_Click(object sender, EventArgs e)   //apply median filter when trippy button is clicked
{
    Bitmap filtered = new Bitmap(img.Width, img.Height);
    filtered = MedianFilter(img, 3);
    pb.Image = filtered;
}

    }



}
